
*     2018/12/27
*     2020/02/19 for additional obs
*     CMIP5 models & Obs
*     trend histgram: 1951-2010
*     raw values are from
*     epac_wpac_sst_trend_hist_cmip.f (model) & merge_timeseries_obs_rev.f (obs)
*

      integer  ncmip, nobs
      integer  nt
      real     t0, dt

      parameter ( ncmip = 27, nobs = 6 )
      parameter ( t0 = -1.05, dt = 0.1, nt = 40 )

      real    hwpac_obs( nt )
      real    hepac_obs( nt )
      real    hdiff_obs( nt )
      real    hwpac_cmip( nt )
      real    hepac_cmip( nt )
      real    hdiff_cmip( nt )
      real    t, t1( nt ), em

      integer  n, m, irec, iem

      real    wpac_obs( nobs )
      real    epac_obs( nobs )
      real    wpac_cmip( ncmip )
      real    epac_cmip( ncmip )

      real    diff_obs( nobs )
      real    diff_cmip( ncmip )
      real    diff_all( ncmip+1+nobs )
      real    tag_all( ncmip+1+nobs )
      real    workx( ncmip+1+nobs )
      real    worky( ncmip+1+nobs )

      character cfr1*8
      character cfo( 6 )*90
      character cobs( nobs )*14
      character cmodel( ncmip+1 )*14
      character ccall( ncmip+1+nobs )*14
      data cfr1
     &/'../data/'/
*       12345678901234567890123456789012345678901234567890

      data cfo(1)
     &/'epac-wpac.sst.trend.nosort.grd'/
      data cfo(2)
     &/'wpac-epac.sst.trend.grd'/
      data cfo(3)
     &/'wpac-epac.sst.trend.histogram.grd'/

c      data wpac_obs
c     &     / 1.16660, 0.908343, 1.12914, 0.964257 /
c      data epac_obs
c     &     / 0.769736, 0.832776, 0.881483, 0.479261 /

* updated w/ ESTTv5
c      data wpac_obs
c     &     / 1.16660, 0.908343, 1.2540, 0.964257 /
c      data epac_obs
c     &     / 0.769736, 0.832776, 0.926614, 0.479261 /
*  COBE, HadI, ERSST, Kaplan
*
* two obs data added
      data wpac_obs
     &     / 1.16660, 1.11349, 1.29400, 0.968599, 0.925219, 1.16465 /
      data epac_obs
     &     / 0.769736, 0.621854, 0.926614, 0.482361, 0.848517, 1.02429 /
*  COBE, HadI, ERSSTv5, Kaplan, HadSST, ICOADS

      data wpac_cmip
     &     / 0.684474, 0.774129, 1.32538, 1.31081, 1.00588, 
     &       1.26889, 0.896972, 0.822775, 0.139059, 1.23119, 
     &       1.02780, 1.47354, 1.07061, 0.724363, 0.579345, 
     &       0.951644, 1.67663, 1.75693, 1.02557, 0.932290, 
     &       0.983434, 0.715807, 1.30925, 1.41156, 0.373249,
     &       0.982079, 0.997622 /

      data epac_cmip
     &     / 0.784190, 0.742394, 1.54367, 1.61368, 1.39929, 
     &       1.64976, 0.557309, 1.21023, 0.203344, 1.47180, 
     &       0.944691, 1.64583, 1.27783, 1.33121, 0.841410, 
     &       1.04938, 1.34888, 1.68460, 0.958962, 1.00196, 
     &       1.05451, 0.608434, 1.27617, 1.41276, 0.659480,
     &       0.663531, 0.754965 /

      data cobs
     &/'COBE-SST2 ',
     & 'HadISST   ',
     & 'ERSSTv5   ',
     & 'Kaplan    ',
     & 'HadSST3.1 ',
     & 'ICOADS    '/

      data cmodel
     &/'access1-0 ',
     & 'access1-3 ',
     & 'bcc ',
     & 'canesm2' ,
     & 'ccsm4' ,
     & 'cesm1-bgc' ,
     & 'cmcc' ,
     & 'cnrm-cm5' ,
     & 'csiro-mk3.6' ,
     & 'fgoals-g2' ,
     & 'gfdl-cm3' ,
     & 'gfdl-esm2g' ,
     & 'gfdl-esm2m' ,
     & 'giss-er' ,
     & 'hadgem2-cc' ,
     & 'hadgem2' ,
     & 'ipsl-cm5-lr' ,
     & 'ipsl-cm5-mr' ,
     & 'ipsl-cm5b-lr' ,
     & 'miroc-esm' ,
     & 'miroc-esm-chem' ,
     & 'miroc5' ,
     & 'mpi-esm-lr' ,
     & 'mpi-esm-mr' ,
     & 'mri-cgcm3' ,
     & 'ncc-noresm1' ,
     & 'ncc-noresm1-me',
     & 'MME mean' /
*       12345678901234

      write( 6,* ) ' @@@ data opened @@@ '
      open( 90,file=cfr1//cfo(1), form='unformatted',
     &     access='direct', recl=4 )
      open( 91,file=cfr1//cfo(2), form='unformatted',
     &     access='direct', recl=4 )
      open( 92,file=cfr1//cfo(3), form='unformatted',
     &     access='direct', recl=4 )
*
      write( 6,* ) ' @@@ linear trends for 1951-2010 '
      em = 0.
      iem = 0
      do n = 1, ncmip
c         write(6,*) cmodel( n )
         diff_cmip( n ) = wpac_cmip( n ) - epac_cmip( n )
         em = em + diff_cmip( n ) / real( ncmip )
      enddo
      write(6,*) cmodel( ncmip+1 )
      do n = 1, nobs
c         write(6,*) cobs( n )
         diff_obs( n ) = wpac_obs( n ) - epac_obs( n )
      enddo

      write( 6,* ) ' @@@ trend values @@@ '

      irec = 0
      do n = 1, ncmip
         irec = irec + 1
         tag_all( irec ) = real( irec )
         diff_all( irec ) = diff_cmip( n )
         ccall( irec ) = cmodel( irec )
         write(6,*) cmodel( n ), -diff_all( irec )
         write( 90, rec=irec ) -diff_cmip( n )
      enddo
      irec = irec + 1
      tag_all( irec ) = real( irec )
      diff_all( irec ) = em
      ccall( irec ) = cmodel( irec )
c      write(6,*) -diff_all( irec )
      write( 90, rec=irec ) -em
      do n = 1, nobs
         irec = irec + 1
         tag_all( irec ) = real( irec )
         diff_all( irec ) = diff_obs( n )
         ccall( irec ) = cobs( n )
         write(6,*) cobs( n ), -diff_all( irec )
         write( 90, rec=irec ) -diff_obs( n )
      enddo

      write( 6,* ) ' @@@ re-ordering trends @@@ '

      call sorting( diff_all, tag_all, ncmip+nobs+1, 
     &     xmiss, workx, worky )
      do n = 1, ncmip+1+nobs
         m = int( tag_all( n ) )
         write(6,*) n, int( tag_all( n ) ),'  ',
     &        ccall( m ), -diff_all( n )
c         write(6,*) -diff_all( n )
         write( 91, rec=n ) diff_all( n )
      enddo

      write( 6,* ) ' @@@ histogram @@@ '

      hwpac_obs = 0.
      hepac_obs = 0.
      hdiff_obs = 0.
      hwpac_cmip = 0.
      hepac_cmip = 0.
      hdiff_cmip = 0.

      t = t0
      do n = 1, nt
         t1( n ) = t + dt/2.
cc         write( 6,* ) t1( n )

         do m = 1, nobs
            if( wpac_obs( m ) .gt. t .and.
     &          wpac_obs( m ) .le. t+dt ) then
               hwpac_obs( n ) = hwpac_obs( n ) + 1./real( nobs )
            endif
            if( epac_obs( m ) .gt. t .and.
     &          epac_obs( m ) .le. t+dt ) then
               hepac_obs( n ) = hepac_obs( n ) + 1./real( nobs )
            endif
            if( diff_obs( m ) .gt. t .and.
     &          diff_obs( m ) .le. t+dt ) then
               hdiff_obs( n ) = hdiff_obs( n ) + 1./real( nobs )
            endif
         enddo

         do m = 1, ncmip
            if( wpac_cmip( m ) .gt. t .and.
     &          wpac_cmip( m ) .le. t+dt ) then
               hwpac_cmip( n ) = hwpac_cmip( n ) + 1./real( ncmip )
            endif
            if( epac_cmip( m ) .gt. t .and.
     &          epac_cmip( m ) .le. t+dt ) then
               hepac_cmip( n ) = hepac_cmip( n ) + 1./real( ncmip )
            endif
            if( diff_cmip( m ) .gt. t .and.
     &          diff_cmip( m ) .le. t+dt ) then
               hdiff_cmip( n ) = hdiff_cmip( n ) + 1./real( ncmip )
            endif
         enddo

         t = t + dt
      enddo

      irec = 0
      do n = 1, nt
         irec = irec + 1
         write( 92, rec=irec ) hwpac_obs( n )
      enddo
      do n = 1, nt
         irec = irec + 1
         write( 92, rec=irec ) hepac_obs( n )
      enddo
      do n = 1, nt
         irec = irec + 1
         write( 92, rec=irec ) hdiff_obs( n )
      enddo
      do n = 1, nt
         irec = irec + 1
         write( 92, rec=irec ) hwpac_cmip( n )
      enddo
      do n = 1, nt
         irec = irec + 1
         write( 92, rec=irec ) hepac_cmip( n )
      enddo
      do n = 1, nt
         irec = irec + 1
         write( 92, rec=irec ) hdiff_cmip( n )
      enddo
      close( 90 )
      close( 91 )
      close( 92 )
*
      stop
      end
************************************************
      subroutine amean( x, xave, xmax, xmin, nx, nw, vms )
*
      integer nx, nw
      real    x( nx,nw )
      real    xave( nx )
      real    xmax( nx )
      real    xmin( nx )
      real    vms
*
      real    xm
      integer n, m, ix

      do n = 1, nx
         xm = 0.
         ix = 0
         xmax( n ) = -1.e8
         xmin( n ) =  1.e8
         do m = 1, nw
            if( x( n,m ) .ne. vms ) then
               xm = xm + x( n,m )
               ix = ix + 1
               xmax( n ) = max( xmax( n ), x( n,m ) )
               xmin( n ) = min( xmin( n ), x( n,m ) )
            endif
         enddo
         if( ix .le. 0 ) then
            xave( n ) = vms
         else
            xave( n ) = xm / real( ix )
         endif
         if( xmax( n ) .eq. -1.e8 ) xmax( n ) = vms
         if( xmin( n ) .eq.  1.e8 ) xmin( n ) = vms
      enddo
*
      return
      end
******************
      SUBROUTINE TREND
     I     ( Y, INT, XMISS,
     O      A, B)  
C
C     [variable]
      INTEGER INT
      REAL*4 XMISS
      REAL*4 Y(INT)
C     [internal]
      REAL*4 XM
      REAL*4 YM
      REAL*4 SXY
      REAL*4 SX2
C     [output]
      REAL*4 A
      REAL*4 B
C
C*****TREND*****     
      N=0  
      XM=0.
      YM=0.
      SXY=0. 
      SX2=0. 
C  
      DO 100 I=1,INT         
         IF(Y(I).NE.XMISS) THEN 
            N=N+1           
            XM=XM+REAL(I)         
            YM=YM+Y(I)      
            SXY=SXY+REAL(I)*Y(I)  
            SX2=SX2+REAL(I)**2   
         ENDIF          
  100 CONTINUE       
C     
      IF( N.EQ. INT ) THEN
         XM=XM/REAL(N)     
         YM=YM/REAL(N)     
         A=(SXY-REAL(N)*XM*YM)/(SX2-REAL(N)*XM**2)  
         B=YM-A*XM    
      ELSE
         A=XMISS
         B=XMISS
      ENDIF
C    
      RETURN  
      END       
*******************************************
      subroutine sorting( x, y, nx, vms, wx, wy )

      integer  nx
      real*4   vms
      real*4   x( nx )
      real*4   y( nx )
      real*4   wx( nx )
      real*4   wy( nx )

      real*4   wp, zp
      integer  n, i, k, np
*
*     sorting x
* 
      do n = 1, nx
         wx( n ) = x( n )
         wy( n ) = y( n )
      enddo
*
      do k = 1, nx
         wp = vms-1.
         np = 0  
         do n = k, nx
            if( wx( n ) .gt. wp ) then
               wp = wx( n )
               zp = wy( n )
               np = n
            endif
         enddo
         wp = wx( k )
         wx( k ) = wx( np )
         wx( np ) = wp  
*
         zp = wy( k )
         wy( k ) = wy( np )
         wy( np ) = zp
      enddo
*
      do k = 1, nx
c         x( k ) = wx( nx+1-k )
         x( k ) = wx( k )
         y( k ) = wy( k )
      enddo
*
      return
      end
