
*     2019/06/13
*     IPSL CM6A LE
*     trend histgram: 1951-2010
*

      integer  nt, ift, ilt, nt2, ne
      integer  ift2, ilt2, nt3, nhist, nhistg, nhistg2
      real     t0, dt, dtg, t02, dtg2, xmiss, hk

      parameter ( nt = 165, ift = 102, ilt = 161 )
      parameter ( nt2 = ilt-ift+1, ne = 30 )
      parameter ( ift2 = 142, ilt2 = 161, nt3 = ilt2-ift2+1 )
      parameter ( t0 = -2.05, dt = 0.1, nhist = 50 )
      parameter ( dtg = 0.01, nhistg = 500 )
      parameter ( t02 = -10.01, dtg2 = 0.02, nhistg2 = 1001 )
      parameter ( xmiss = -999. )
      parameter ( hk = 0.0000001 ) !! kernel parameter

      real    sst( nt, ne )
      real    tr( ne ), trem, trsgm
      real    tr2( ne ), tr2em, tr2sgm
      real    t, tn, t1( nhist ), t90p, t90m
      real    pdfsum
      real    hist( nhist )
      real    pdf( nhist )
      real    pdf_90( nhist )
      real    pdfg( nhistg )
      real    pdfg_90( nhistg )
      real    pdfg2( nhistg2 )
      
      real    x( nt2 )
      real    y( nt3 )
      real    a_tr, b_tr
      real    trm, trs

      integer  n, m, ie, irec

      character cfr1*8
      character cfi( 6 )*90
      character cfo( 6 )*90

      data cfr1
     &/'../data/'/
*       12345678901234567890123456789012345678901234567890

      data cfi(1)
     &/'sst.ipsl-le.epac-wpac.run001-030.ann.anm.grd'/

      data cfo(1)
     &/'sst.ipsl-le.epac-wpac.run001-030.trend.histogram.grd'/
      data cfo(2)
     &/'sst.ipsl-le.epac-wpac.run001-030.trend.pdfgauss.grd'/
      data cfo(3)
     &/'sst.ipsl-le.epac-wpac.run001-030.trend.pdfgauss.1991-2010.grd'/
*
      write( 6,* ) ' @@@ data opened @@@ '
      open( 10,file=cfr1//cfi(1), form='unformatted',
     &     access='direct', recl=4 )

      open( 91,file=cfr1//cfo(1), form='unformatted',
     &     access='direct', recl=4 )
      open( 92,file=cfr1//cfo(2), form='unformatted',
     &     access='direct', recl=4 )
      open( 93,file=cfr1//cfo(3), form='unformatted',
     &     access='direct', recl=4 )
*
      write( 6,* ) ' @@@ read data '
*
      irec = 0
      do n = 1, nt
         do ie = 1, ne
            irec = irec + 1
            read( 10, rec = irec ) sst( n,ie )
         enddo
      enddo
      close( 10 )
*
      write( 6,* ) ' @@@ linear trends for 1951-2010 '
      tr = xmiss
      trm = 0.
      trs = 0.
      do ie = 1, ne
         do n = ift, ilt
            x( n-ift+1 ) = sst( n,ie )
         enddo
         call trend( x, nt2, xmiss, a_tr, b_tr )
         if( a_tr .ne. xmiss ) then
            tr( ie ) = a_tr * 100.
         else
            write( 6,* ) ' ### trend missing at n= ', ie
         endif
c         write(6,*) ie, tr(ie)
         trm = trm + tr( ie ) / real( ne ) 
c         write(6,*) tr(ie)
      enddo
      do ie = 1, ne
         trs = trs + ( tr( ie )-trm )**2 / real( ne ) 
      enddo
      trs = sqrt( trs ) * 1.645
      write( 6,* ) '    @@@ mean = ', trm
      write( 6,* ) '    @@@ 5-95% = ', trm-trs, trm+trs
*
      write( 6,* ) ' @@@ linear trends for 1991-2010 '
      tr2 = xmiss
      trm = 0.
      trs = 0.
      do ie = 1, ne
         do n = ift2, ilt2
            y( n-ift2+1 ) = sst( n,ie )
         enddo
         call trend( y, nt3, xmiss, a_tr, b_tr )
         if( a_tr .ne. xmiss ) then
            tr2( ie ) = a_tr * 100.
         else
            write( 6,* ) ' ### trend missing at n= ', ie
         endif
c         write(6,*) ie, tr(ie)
         trm = trm + tr2( ie ) / real( ne ) 
      enddo
      do ie = 1, ne
         trs = trs + ( tr2( ie )-trm )**2 / real( ne ) 
      enddo
      trs = sqrt( trs )
      write( 6,* ) '    @@@ mean = ', trm
      write( 6,* ) '    @@@ sigma = ', trs
      trs = trs * 1.645
      write( 6,* ) '    @@@ 5-95% = ', trm-trs, trm+trs
*
      write( 6,* ) ' @@@ histogram @@@ '
*
      hist = 0.
      t = t0
      do m = 1, nhist
         t1( m ) = t + dt/2.
cc         write( 6,* ) t1( m )
         do ie = 1, ne
            if( tr( ie ) .gt. t .and.
     &          tr( ie ) .le. t+dt ) then
               hist( m ) = hist( m ) + 1./real( ne )
            endif
         enddo
         t = t + dt
      enddo
*
*     PDF
*
      write( 6,* ) ' @@@ PDF @@@ '
*
      pdf = 0.
      call pdf_1d_kernel_KG_2
     &     ( tr, pdf, ne, nhist, t0, dt, xmiss, hk )

      pdf_90 = 0.
      pdfsum = 0.
      t = 0.
      tn = 0.
      do m = 1, nhist
         pdfsum = pdfsum + pdf( m ) * dt
         if( pdfsum .le. 0.05 ) then
            t = 1.
         else
            if( t .eq. 1. ) then
               pdf_90( m ) = 1.
               t = 0.
            endif
         endif
         if( pdfsum .gt. 0.95 .and. tn .eq. 0. ) then
            tn = 1.
            pdf_90( m ) = 1.
         endif
      enddo
*
      write( 6,* ) ' @@@ PDF (Gaussian) @@@ '
      pdfg = 0.
      call pdf_gauss
     &     ( tr, ne, trem, trsgm, nhistg, t0, dtg, xmiss, pdfg )
      write( 6,* ) ' @@@ ensemble mean trend 1951-2010 = ',
     &     trem, ' K/100yr @@@ '


      pdfg_90 = 0.
      do m = 1, nhistg
         t = t0 + real( m-1 )*dtg
         tn = t + dtg
         t90m = trem-sqrt(trsgm)*1.645
         t90p = trem+sqrt(trsgm)*1.645
         if( t90m .ge. t .and. t90m .lt. tn ) then
            pdfg_90( m ) = 1.
         endif
         if( t90p .gt. t .and. t90p .le. tn ) then
            pdfg_90( m ) = 1.
         endif
      enddo
*
      write( 6,* ) ' @@@ PDF (Gaussian) @@@ '
      pdfg2 = 0.
      call pdf_gauss
     &     ( tr2, ne, tr2em, tr2sgm, nhistg2, t02, dtg2, xmiss, pdfg2 )
      write( 6,* ) ' @@@ ensemble mean trend 1991-2010 = ',
     &     tr2em, ' K/100yr @@@ '

      write( 6,* ) ' @@@ write @@@ '
*
      irec = 0
      do m = 1, nhist
         irec = irec + 1
         write( 91, rec=irec ) hist( m )
      enddo
      do m = 1, nhist
         irec = irec + 1
         write( 91, rec=irec ) pdf( m )
      enddo
      do m = 1, nhist
         irec = irec + 1
         write( 91, rec=irec ) pdf_90( m )
      enddo

      irec = 0
      do m = 1, nhistg
         irec = irec + 1
         write( 92, rec=irec ) pdfg( m )
      enddo
      do m = 1, nhistg
         irec = irec + 1
         write( 92, rec=irec ) pdfg_90( m )
      enddo

      irec = 0
      do m = 1, nhistg2
         irec = irec + 1
         write( 93, rec=irec ) pdfg2( m )
      enddo
      close( 91 )
      close( 92 )
      close( 93 )
*
      stop
      end
******************
      SUBROUTINE TREND
     I     ( Y, INT, XMISS,
     O      A, B)  
C
C     [variable]
      INTEGER INT
      REAL*4 XMISS
      REAL*4 Y(INT)
C     [internal]
      REAL*4 XM
      REAL*4 YM
      REAL*4 SXY
      REAL*4 SX2
C     [output]
      REAL*4 A
      REAL*4 B
C
C*****TREND*****     
      N=0  
      XM=0.
      YM=0.
      SXY=0. 
      SX2=0. 
C  
      DO 100 I=1,INT         
         IF(Y(I).NE.XMISS) THEN 
            N=N+1           
            XM=XM+REAL(I)         
            YM=YM+Y(I)      
            SXY=SXY+REAL(I)*Y(I)  
            SX2=SX2+REAL(I)**2   
         ENDIF          
  100 CONTINUE       
C     
      IF( N.EQ. INT ) THEN
         XM=XM/REAL(N)     
         YM=YM/REAL(N)     
         A=(SXY-REAL(N)*XM*YM)/(SX2-REAL(N)*XM**2)  
         B=YM-A*XM    
      ELSE
         A=XMISS
         B=XMISS
      ENDIF
C    
      RETURN  
      END       
*******************************************
      subroutine sorting( x, y, nx, vms, wx, wy )

      integer  nx
      real*4   vms
      real*4   x( nx )
      real*4   y( nx )
      real*4   wx( nx )
      real*4   wy( nx )

      real*4   wp, zp
      integer  n, i, k, np
*
*     sorting x
* 
      do n = 1, nx
         wx( n ) = x( n )
         wy( n ) = y( n )
      enddo
*
      do k = 1, nx
         wp = vms-1.
         np = 0  
         do n = k, nx
            if( wx( n ) .gt. wp ) then
               wp = wx( n )
               zp = wy( n )
               np = n
            endif
         enddo
         wp = wx( k )
         wx( k ) = wx( np )
         wx( np ) = wp  
*
         zp = wy( k )
         wy( k ) = wy( np )
         wy( np ) = zp
      enddo
*
      do k = 1, nx
c         x( k ) = wx( nx+1-k )
         x( k ) = wx( k )
         y( k ) = wy( k )
      enddo
*
      return
      end
*******************************************
      subroutine pdf_gauss
     &     ( x, nx, xm, xs, nh, h0, dh, vms, pdf )

      integer  nx, nh
      real     vms, xm, xs, h0, dh, h
      real     x( nx )
      real     pdf( nh )
      real     p1, p2, pi, pdftot, alpha

      integer  n, i, ixm
*
*     mean and sigma
*
      xm = 0.
      ixm = 0
      do i = 1, nx
         if( x( i ) .ne. vms ) then
            xm = xm + x( i )
            ixm = ixm + 1
         endif
      enddo
      xm = xm / real( ixm )
*
      xs = 0.
      do i = 1, nx
         if( x( i ) .ne. vms ) then
            xs = xs + ( x( i )-xm )**2
         endif
      enddo
      xs = xs / real( ixm )

*
*     Gaussian PDF
* 
      pi = atan( 1.0 )*4.0
      p1 = 1. / sqrt( 2.*pi*xs )
      h = h0
      do n = 1, nh
         h = h0 + dh * real( n-1 ) + dh/2.
         p2 = ( h - xm )**2 / ( 2.*xs )
         pdf( n ) = p1 * exp( -p2 ) 
c         write(6,*) h
      enddo
*
*     Normalization
*
      pdftot = 0.
      do n = 1, nh
         pdftot = pdftot + pdf( n ) * dh
      enddo
      write( 6,* ) '    Integral First PDF = ', pdftot
      alpha = 1.0 / pdftot
      pdftot = 0.0
      do n = 1, nh
         pdf( n ) = pdf( n ) * alpha
         pdftot = pdftot + pdf( n ) * dh
      enddo
      write( 6,* ) '    Integral PDF = ', pdftot
      write( 6,* )
*
      return
      end
**************************************************
* 2007/01/13 from "pdf.1d.kernel.KG.1.F"

* Calculate Probability Density Function to use Kernel Function.
* Procedure is followed in Kimoto and Ghil (1993a) step (1) only.
* Band with (smoothing parameter) was calculated by " pdf.LSCV.F ".

      SUBROUTINE pdf_1d_kernel_KG_2
     &     ( X, PDF4, NT, NX, XS, DX, MISS, HK )

      IMPLICIT none

      INTEGER       NT
*
      INTEGER       NX          ! total number of X-axis grid
      REAL*4        XS          ! start value of X-axis
      REAL*4        DX          ! interval of X-axis grid
      REAL*4        HK
*
      REAL*4        MISS

      REAL*4             x   ( nt )
      REAL*4             PDF4 ( nx )
*

*[ WORK ]
      INTEGER            it
      INTEGER            i , j
      INTEGER            n
      INTEGER            irec
      REAL               work, x1
      REAL*8             dwork
      REAL*4             PDF ( nx )
*
      REAL*8             KF               ! kernel function
      REAL*8             xx
      REAL*8             yy
      REAL*8             alpha

*[ NAMELIST ]
      INTEGER            nv , mv
      REAL*8             h
*
*     Calculate PDF
*
      H = DBLE( HK )
      DO i = 1 , nx

         xx = DBLE( xs ) + DBLE( ( i - 1 ) ) * DBLE( dx )

         n = 0
         dwork = 0.0D0
         DO it = 1, nt

            IF ( x( it ) .NE. DBLE( miss ) ) THEN

               n = n + 1
               x1 = xx - dble( x( it ) )

               dwork = dwork
     &              + KF( x1 , 0.d0 , h )

            END IF

         END DO

         PDF( i ) =  dwork / DBLE( n )

      END DO

cc      WRITE( 6 , * )
      WRITE( 6 , * ) '    Total Number of Input Data       =', nt
      WRITE( 6 , * ) '    Number of Used Data to Calculate =', n

*
*     Normalization
*
      dwork = 0.0d0
      DO i = 1, nx
         dwork = dwork + PDF( i ) * DX 
      END DO

      WRITE( * , * ) '    Integral First PDF = ', dwork

      alpha = 1.0d0 / dwork

      dwork = 0.0d0
      DO i = 1, nx
         PDF( i ) = PDF( i ) * alpha
         dwork = dwork + PDF( i ) * DX 
         PDF4( i ) = SNGL( PDF( i ) )
      END DO

      WRITE( 6 , * ) '    Integral PDF = ', dwork
      WRITE( 6 , * )

      RETURN
      END

************************************************************************
* 2007/01/12
* Kernel Function to calculate pilot PDF : Epanechnikov kernel
* (Kimoto and Ghil, 1993a)

      FUNCTION KF ( X , Y , h )

      IMPLICIT none

      REAL*8   KF
      REAL*8   X
      REAL*8   Y
      REAL*8   h

*[ WORK ]
      REAL*8   wx , wy , work

      wx = X / h
      wy = Y / h

      work = wx * wx + wy * wy

      IF ( work .LT. 1.0d0 ) THEN

         KF = ( 1.0d0 - work ) * 3.0d0 / 4.0d0

      ELSE

         KF = 0.0d0

      END IF

      END
