* 2018/12/17
* 2020/03/08
*
      implicit none

      integer ilon, nlev, nt, nmo, ithre
      integer ify, ily, ny
      integer ify2, ily2, ny2
      integer ify3, ily3, ny3
      real*4  vms, r95, r99

      parameter ( ilon = 360, nlev = 24 )
      parameter ( nt = 70, nmo = 12, ithre = nmo )
      parameter ( ify = 7, ily = 66, ny = ily-ify+1 )
      parameter ( ify2 = 7, ily2 = 51, ny2 = ily2-ify2+1 )
c      parameter ( ify2 = 7, ily2 = 36, ny2 = ily2-ify2+1 )
      parameter ( ify3 = 37, ily3 = 66, ny3 = ily3-ify3+1 )
      parameter ( vms = -999., r95 = 0.254, r99 = 0.33 )

      real    t( ilon )
      real    tm( ilon,nlev,nt )
      real    tr( ilon,nlev )
      real    sig( ilon,nlev )
      real    tr2( ilon,nlev )
      real    sig2( ilon,nlev )
      real    tr3( ilon,nlev )
      real    sig3( ilon,nlev )

      real    x( ny )
      real    y( ny )
      real    x2( ny2 )
      real    y2( ny2 )
      real    x3( ny3 )
      real    y3( ny3 )
      real    a_tr, b_tr, cor
      real    a_tr2, b_tr2, cor2
      real    a_tr3, b_tr3, cor3

      integer  n, m, i, k, irec
      integer  itm( ilon,nlev,nt )

      character cfr1*8
      character cfi( 6 )*90
      character cfo( 8 )*90
      data cfr1
     &/'../data/'/
*       12345678901234567890123456789012345678901234567890
 
      data cfi(1)
     &/'teq_proj6.14_mon_anm_base1971-2000.grd'/
*       12345678901234567890123456789012345678901234567890123

      data cfo( 1 )
     &/'teq_proj6.14_ann_anm_base1971-2000.grd'/
      data cfo( 2 )
     &/'teq_proj6.14_ann_trend_1951-2010.grd'/
      data cfo( 3 )
     &/'teq_proj6.14_ann_trend_1951-1980.grd'/
      data cfo( 4 )
     &/'teq_proj6.14_ann_trend_1981-2010.grd'/

      write( 6,* ) ' @@@ Annual mean anomaly '

      open( 10, file=cfr1//cfi(1), form='unformatted',
     &     access='direct', recl=4*ilon )

      open( 91, file=cfr1//cfo(1), form='unformatted',
     &     access='direct', recl=4*ilon )
      open( 92, file=cfr1//cfo(2), form='unformatted',
     &     access='direct', recl=4*ilon )
      open( 93, file=cfr1//cfo(3), form='unformatted',
     &     access='direct', recl=4*ilon )
      open( 94, file=cfr1//cfo(4), form='unformatted',
     &     access='direct', recl=4*ilon )
*
      write( 6,* ) ' @@@ read data '
      irec = 0
      tm = 0.
      itm = 0
      do n = 1, nt
         do m = 1, nmo
            do k = 1, nlev
               irec = irec + 1
               read( 10, rec=irec ) t
               do i = 1, ilon
                  if( t( i ) .ne. vms ) then
                     tm( i,k,n ) = tm( i,k,n ) + t( i )
                     itm( i,k,n ) = itm( i,k,n ) + 1
                  endif
               enddo
            enddo               !! k
         enddo                  !! m
      enddo                     !! n
*
      write( 6,* ) ' @@@ write annual mean '
      irec = 0
      do n = 1, nt
         do k = 1, nlev
            do i = 1, ilon
               if( itm( i,k,n ) .lt. ithre ) then
                  tm( i,k,n ) = vms
               else
                  tm( i,k,n ) = tm( i,k,n ) / real( itm( i,k,n ) )
               endif
            enddo
            irec = irec + 1
            write( 91, rec = irec ) ( tm(i,k,n),i=1,ilon )
         enddo
      enddo
*
      write( 6,* ) ' @@@ linear trends for 1951-2010 '
      tr = vms
      sig = 0.
      do n = 1, ny
         x( n ) = real( n )
      enddo
      do k = 1, nlev
         do i = 1, ilon
            do n = ify, ily
               y( n-ify+1 ) = tm( i,k,n )
            enddo
            call trend( y, ny, vms, a_tr, b_tr )
            if( a_tr .ne. vms ) then
               tr( i,k ) = a_tr * 100. !! per 100yr
            endif
            call regcor( x, y, ny/2, ny, vms, a_tr, b_tr, cor )
            if( abs( cor ) .gt. r99 ) then
               sig( i,k ) = 10.
            else if( abs( cor ) .gt. r95 ) then
               sig( i,k ) = 5.
            endif
c            sig( i,k ) = cor
         enddo
      enddo
*
      write( 6,* ) ' @@@ linear trends for 1951-1980 '
      tr2 = vms
      sig2 = 0.
      do n = 1, ny2
         x2( n ) = real( n )
      enddo
      do k = 1, nlev
         do i = 1, ilon
            do n = ify2, ily2
               y2( n-ify2+1 ) = tm( i,k,n )
            enddo
            call trend( y2, ny2, vms, a_tr2, b_tr2 )
            if( a_tr2 .ne. vms ) then
               tr2( i,k ) = a_tr2 * 100. !! per 100yr
            endif
            call regcor( x2, y2, ny2/2, ny2, vms, a_tr2, b_tr2, cor2 )
            if( abs( cor2 ) .gt. r99 ) then
               sig2( i,k ) = 10.
            else if( abs( cor2 ) .gt. r95 ) then
               sig2( i,k ) = 5.
            endif
         enddo
      enddo
*
      write( 6,* ) ' @@@ linear trends for 1981-2010 '
      tr3 = vms
      sig3 = 0.
      do n = 1, ny3
         x3( n ) = real( n )
      enddo
      do k = 1, nlev
         do i = 1, ilon
            do n = ify3, ily3
               y3( n-ify3+1 ) = tm( i,k,n )
            enddo
            call trend( y3, ny3, vms, a_tr3, b_tr3 )
            if( a_tr3 .ne. vms ) then
               tr3( i,k ) = a_tr3 * 100. !! per 100yr
            endif
            call regcor( x3, y3, ny3/2, ny3, vms, a_tr3, b_tr3, cor3 )
            if( abs( cor3 ) .gt. r99 ) then
               sig3( i,k ) = 10.
            else if( abs( cor3 ) .gt. r95 ) then
               sig3( i,k ) = 5.
            endif
         enddo
      enddo
*
      write( 6,* ) ' @@@ write linear trends '

      irec = 0
      do k = 1, nlev
         irec = irec + 1
         write( 92, rec = irec ) ( tr(i,k),i=1,ilon )
         write( 93, rec = irec ) ( tr2(i,k),i=1,ilon )
         write( 94, rec = irec ) ( tr3(i,k),i=1,ilon )
      enddo
      do k = 1, nlev
         irec = irec + 1
         write( 92, rec = irec ) ( sig(i,k),i=1,ilon )
         write( 93, rec = irec ) ( sig2(i,k),i=1,ilon )
         write( 94, rec = irec ) ( sig3(i,k),i=1,ilon )
      enddo
*
      close( 10 )
      close( 91 )
      close( 92 )
      close( 93 )
      close( 94 )
*
      stop
      end
******************
      SUBROUTINE TREND
     I     ( Y, INT, XMISS,
     O      A, B)  
C
C     [variable]
      INTEGER INT
      REAL*4 XMISS
      REAL*4 Y(INT)
C     [internal]
      REAL*4 XM
      REAL*4 YM
      REAL*4 SXY
      REAL*4 SX2
C     [output]
      REAL*4 A
      REAL*4 B
C
C*****TREND*****     
      N=0  
      XM=0.
      YM=0.
      SXY=0. 
      SX2=0. 
C  
      DO 100 I=1,INT         
         IF(Y(I).NE.XMISS) THEN 
            N=N+1           
            XM=XM+REAL(I)         
            YM=YM+Y(I)      
            SXY=SXY+REAL(I)*Y(I)  
            SX2=SX2+REAL(I)**2   
         ENDIF          
  100 CONTINUE       
C     
      IF( N.EQ. INT ) THEN
         XM=XM/REAL(N)     
         YM=YM/REAL(N)     
         A=(SXY-REAL(N)*XM*YM)/(SX2-REAL(N)*XM**2)  
         B=YM-A*XM    
      ELSE
         A=XMISS
         B=XMISS
      ENDIF
C    
      RETURN  
      END       
************************************************
      SUBROUTINE REGCOR
     I     ( X, Y, ITHRE, INT, XMISS,
     O     REGA, REGB, COR ) 
*
      REAL*4 X(INT)
      REAL*4 Y(INT)
      REAL*4 XMISS
      REAL*4 REGA, REGB, COR
*     
*     [work]
      REAL*4 XM
      REAL*4 YM
      REAL*4 SXY
      REAL*4 SX2
      REAL*4 SY2
*     
*
      N = 0 
      XM = 0.E0
      YM = 0.E0 
      SXY = 0.E0
      SX2 = 0.E0
      SY2 = 0.E0
      REG = 0.E0
      COR = 0.E0
*
      DO 100 I = 1, INT
         IF( X( I ) .NE. XMISS .AND. Y( I ) .NE. XMISS ) THEN
            N = N + 1
            XM = XM + X( I )
            YM = YM + Y( I ) 
         ENDIF         
  100 CONTINUE
*
      IF( N .LT. ITHRE ) THEN
         REGA = XMISS
         REGB = XMISS
         COR = XMISS
         GOTO 300
      ELSE
         XM = XM / REAL( N )
         YM = YM / REAL( N )
      ENDIF
*
      DO 200 I = 1, INT
         IF( X( I ) .NE. XMISS .AND. Y( I ) .NE. XMISS ) THEN
            SXY = SXY + ( X( I ) - XM ) * ( Y( I ) - YM )
            SX2 = SX2 + ( X( I ) - XM ) * ( X( I ) - XM )
            SY2 = SY2 + ( Y( I ) - YM ) * ( Y( I ) - YM )
         ENDIF
  200 CONTINUE
*
      IF( SX2 .EQ. 0.0E+8 ) THEN
         REGA = XMISS
         REGB = XMISS
         COR = XMISS
      ELSE
         REGA = SXY / SX2
         REGB = YM - XM * REGA
         SXY = SXY / REAL( N )
         SX2 = SQRT( SX2 / REAL( N ) )
         SY2 = SQRT( SY2 / REAL( N ) )
         COR = SXY / SX2 / SY2
      ENDIF
*
  300 RETURN 
      END

