
*     2018/12/18 for extending periods
*     annual mean ocean temp
*     multi model ensemble for 1901-2100 by T Suzuki
*     pre process, kmt:~MIROC4.5/exec/mk_to_ann_xxx.gs
*
      integer  nrun, ncomp, nyr, ift, ilt, nyr2, nx, ny, nz
      integer  iclmf, iclml, nclm
      real     vms, xmiss, r95, r99
      parameter ( nrun = 27, ncomp = 6 )
      parameter ( nyr = 200, ift = 51, ilt = 110 )
      parameter ( nyr2 = ilt-ift+1, nx = 360, ny = 1, nz = 14 )
      parameter ( iclmf = 71, iclml = 100, nclm = iclml-iclmf+1 ) !! clim 1971-2000
      parameter ( vms = 1.e20, xmiss = -999. )
      parameter ( r95 = 0.254, r99 = 0.33 )

      integer   ij, k, m, n, irun, irec, ia, ib, it

      real      to( nx*ny )
      real      toclm( nx*ny,nz,nrun )
      real      toa( nx*ny,nz,nrun )
      real      em( nx*ny,nz )
      real      toa2( nx*ny,nz,nyr2,nrun+1 )
      real      toa2s( nx*ny,nz,nyr2 )
      real      toa2w( nx*ny,nz,nyr2 )

      real      tr( nx*ny,nz,nrun+1 )
      real      sig( nx*ny,nz )
      real      agr( nx*ny,nz )

      real      x1( nyr2 )
      real      y1( nyr2 )
      real      a_tr1, b_tr1, cor1

      real      toclms( nx*ny,nz )
      real      trs( nx*ny,nz )
      real      sigs( nx*ny,nz )
      real      agrs( nx*ny,nz )

      real      toclmw( nx*ny,nz )
      real      trw( nx*ny,nz )
      real      sigw( nx*ny,nz )
      real      agrw( nx*ny,nz )

      integer   itoclm( nx*ny,nz )
      integer   itoclm2( nx*ny,nz )
      integer   iem( nx*ny,nz )
      integer   itrs( nx*ny,nz )
      integer   itrw( nx*ny,nz )

      integer   ismodel( ncomp )    !! models w/ strengthened SST gradient
      integer   iwmodel( ncomp )    !! models w/ weakened SST gradient

      character cfr1*17
      character cfii( nrun )*90
      character cfo( 5 )*90
      character cmodel( nrun )*14
      data cfr1
     &/'../data/mme_toeq/'/
*       12345678901234567890123456789012345678901234567890

      data cfii
     &/'access1-0.hist+rcp45.ann.eq.grd',
     & 'access1-3.hist+rcp45.ann.eq.grd',
     & 'bcc.hist+rcp45.ann.eq.grd',
     & 'canesm2.hist+rcp45.ann.eq.grd' ,
     & 'ccsm4.hist+rcp45.ann.eq.grd' ,
     & 'cesm1-bgc.hist+rcp45.ann.eq.grd' ,
     & 'cmcc.hist+rcp45.ann.eq.grd' ,
     & 'cnrm-cm5.hist+rcp45.ann.eq.grd' ,
     & 'csiro-mk3.6.hist+rcp45.ann.eq.grd' ,
     & 'fgoals-g2.hist+rcp45.ann.eq.grd' ,
     & 'gfdl-cm3.hist+rcp45.ann.eq.grd' ,
     & 'gfdl-esm2g.hist+rcp45.ann.eq.grd' ,
     & 'gfdl-esm2m.hist+rcp45.ann.eq.grd' ,
     & 'giss-er.hist+rcp45.ann.eq.grd' ,
     & 'hadgem2-cc.hist+rcp45.ann.eq.grd' ,
     & 'hadgem2.hist+rcp45.ann.eq.grd' ,
     & 'ipsl-cm5-lr.hist+rcp45.ann.eq.grd' ,
     & 'ipsl-cm5-mr.hist+rcp45.ann.eq.grd' ,
     & 'ipsl-cm5b-lr.hist+rcp45.ann.eq.grd' ,
     & 'miroc-esm.hist+rcp45.ann.eq.grd' ,
     & 'miroc-esm-chem.hist+rcp45.ann.eq.grd' ,
     & 'miroc5.hist+rcp45.ann.eq.grd' ,
     & 'mpi-esm-lr.hist+rcp45.ann.eq.grd' ,
     & 'mpi-esm-mr.hist+rcp45.ann.eq.grd' ,
     & 'mri-cgcm3.hist+rcp45.ann.eq.grd',
     & 'ncc-noresm1.hist+rcp45.ann.eq.grd' ,
     & 'ncc-noresm1-me.hist+rcp45.ann.eq.grd' /

      data cfo(1)
     &/'Teq.hist+rcp45.ann.clm.grd'/ 
      data cfo(2)
     &/'Teq.hist+rcp45.ann.anm.grd'/ 
      data cfo(3)
     &/'Teq.hist+rcp45.ann.anm.trend1951-2010.grd'/ 
      data cfo(4)
     &/'Teq.hist+rcp45.ann.anm.trend1951-2010.smodel.grd'/ 
      data cfo(5)
     &/'Teq.hist+rcp45.ann.anm.trend1951-2010.wmodel.grd'/ 

      data cmodel
     &/'access1-0',
     & 'access1-3',
     & 'bcc',
     & 'canesm2' ,
     & 'ccsm4' ,
     & 'cesm1-bgc' ,
     & 'cmcc' ,
     & 'cnrm-cm5' ,
     & 'csiro-mk3.6' ,
     & 'fgoals-g2' ,
     & 'gfdl-cm3' ,
     & 'gfdl-esm2g' ,
     & 'gfdl-esm2m' ,
     & 'giss-er' ,
     & 'hadgem2-cc' ,
     & 'hadgem2' ,
     & 'ipsl-cm5-lr' ,
     & 'ipsl-cm5-mr' ,
     & 'ipsl-cm5b-lr' ,
     & 'miroc-esm' ,
     & 'miroc-esm-chem' ,
     & 'miroc5' ,
     & 'mpi-esm-lr' ,
     & 'mpi-esm-mr' ,
     & 'mri-cgcm3' ,
     & 'ncc-noresm1' ,
     & 'ncc-noresm1-me' /
*       12345678901234

      data ismodel / 7, 17, 26, 27, 22, 11/
      data iwmodel / 25, 4, 6, 8, 5, 14 /

      write( 6,* )
     &    ' @@@ Teq in CMIP5 hist+rcp4.5 for 1901-2100'

      open( 91,file=cfr1//cfo(1), form='unformatted',
     &     access='direct', recl=4*nx )
      open( 92,file=cfr1//cfo(2), form='unformatted',
     &     access='direct', recl=4*nx )
      open( 93,file=cfr1//cfo(3), form='unformatted',
     &     access='direct', recl=4*nx )
      open( 94,file=cfr1//cfo(4), form='unformatted',
     &     access='direct', recl=4*nx )
      open( 95,file=cfr1//cfo(5), form='unformatted',
     &     access='direct', recl=4*nx )

      write( 6,* )
      write( 6,* )
     &    ' @@@ annual mean Teq data'

      write( 6,* )
      write( 6,* )
     &    ' @@@ models: '
      do irun = 1, nrun
         write( 6,* ) cmodel( irun )
         open( 10+irun, file=cfr1//cfii(irun), form='unformatted',
     &        access='direct', recl=4*nx )
      enddo
      write( 6,* )
*
      write( 6,* )
     &    ' @@@ make 1971-2000 climatology'
      toclm = 0.
      jrec = 0
      em = 0.
      iem = 0
      do irun = 1, nrun

         irec = ( iclmf-1 )*nz
         itoclm = 0
         do n = iclmf, iclml
            do k = 1, nz
               irec = irec + 1
               read( 10+irun, rec=irec ) to
               do ij = 1, nx*ny
                  if( to( ij ) .ne. vms ) then
                     toclm( ij,k,irun ) = toclm( ij,k,irun ) + to( ij )
                     itoclm( ij,k ) = itoclm( ij,k ) + 1
                  endif
               enddo
            enddo               !! k
         enddo !! n
*
         do k = 1, nz
            do ij = 1, nx*ny
               if( itoclm( ij,k ) .lt. nclm/2 ) then
                  toclm( ij,k,irun ) = xmiss
               else
                  toclm( ij,k,irun ) = toclm( ij,k,irun )
     &                 / real( itoclm( ij,k ) )
                  em( ij,k ) = em( ij,k ) + toclm( ij,k,irun )
                  iem( ij,k ) = iem( ij,k ) + 1
               endif
            enddo
            jrec = jrec + 1
            write( 91, rec=jrec ) ( toclm( ij,k,irun ),ij=1,nx*ny )
         enddo                  !! k
         rewind( 10+irun )
      enddo                     !! irun

      do k = 1, nz
         do ij = 1, nx*ny
            if( iem( ij,k ) .gt. nrun/2 ) then
               em( ij,k ) = em( ij,k ) / real( iem( ij,k ) )
            else
               em( ij,k ) = xmiss
            endif
         enddo
         jrec = jrec + 1
         write( 91, rec=jrec ) ( em( ij,k ),ij=1,nx*ny )
      enddo
      close( 91 )
*
      toclms = 0.
      toclmw = 0.
      itoclm = 0
      itoclm2 = 0
      do k = 1, nz
         do ij = 1, nx*ny
            do irun = 1, nrun
               do m = 1, ncomp
                  if( irun .eq. ismodel( m ) ) then
                     if( toclm( ij,k,irun ) .ne. xmiss ) then
                        toclms( ij,k ) = 
     &                       toclms( ij,k ) + toclm( ij,k,irun )
                        itoclm( ij,k ) = itoclm( ij,k ) + 1 
                     endif
                  endif
                  if( irun .eq. iwmodel( m ) ) then
                     if( toclm( ij,k,irun ) .ne. xmiss ) then
                        toclmw( ij,k ) = 
     &                       toclmw( ij,k ) + toclm( ij,k,irun )
                        itoclm2( ij,k ) = itoclm2( ij,k ) + 1 
                     endif
                  endif
               enddo            !! m
            enddo               !! irun
         enddo                  !! ij
      enddo                     !! k

      do k = 1, nz
         do ij = 1, nx*ny
            if( itoclm( ij,k ) .lt. ncomp ) then
               toclms( ij,k ) = xmiss 
            else
               toclms( ij,k ) = toclms( ij,k )
     &                 / real( itoclm( ij,k ) )
            endif
            if( itoclm2( ij,k ) .lt. ncomp ) then
               toclmw( ij,k ) = xmiss 
            else
               toclmw( ij,k ) = toclmw( ij,k )
     &                 / real( itoclm2( ij,k ) )
            endif
         enddo                  !! ij
      enddo                     !! k
*
      irec = 0
      jrec = 0
      write( 6,* )
     &    ' @@@ make 1901-2100 anomaly'
      do n = 1, nyr
cc         write( 6,* ) ' year = ', n+1900

         em = 0.
         iem = 0
         do k = 1, nz
            irec = irec + 1
            do irun = 1, nrun
               read( 10+irun, rec=irec ) to
               do ij = 1, nx*ny
                  if( to( ij ) .ne. vms .and. 
     &                toclm( ij,k,irun ) .ne. xmiss ) then
                     toa( ij,k,irun ) = to( ij ) - toclm( ij,k,irun )
                     em( ij,k ) = em( ij,k ) + toa( ij,k,irun )
                     iem( ij,k ) = iem( ij,k ) + 1
                  else
                     toa( ij,k,irun ) = xmiss
                  endif
               enddo

            enddo               !! irun
         enddo                  !! k

         do k = 1, nz
            do ij = 1, nx*ny
               if( iem( ij,k ) .gt. nrun/2 ) then
                  em( ij,k ) = em( ij,k ) / real( iem( ij,k ) )
               else
                  em( ij,k ) = xmiss
               endif
            enddo
         enddo

         do irun = 1, nrun
            do k = 1, nz
               jrec = jrec + 1
               write( 92, rec=jrec ) ( toa( ij,k,irun ),ij=1,nx*ny )
            enddo
         enddo
         do k = 1, nz
            jrec = jrec + 1
            write( 92, rec=jrec ) ( em( ij,k ),ij=1,nx*ny )
         enddo

      enddo                     !! n
      do irun = 1, nrun
         close( 10+irun )
      enddo
      rewind( 92 )
      
      write( 6,* )
     &    ' @@@ make 1951-2010 trends'
      irec = 0
      it = 0
      toa2s = 0.
      toa2w = 0.
      do n = 1, nyr 
         if( n .ge. ift .and. n .le. ilt ) it = it + 1
         itrs = 0
         itrw = 0
         do irun = 1, nrun+1
            do k = 1, nz
               irec = irec + 1
               read( 92, rec=irec ) to

               if( n .ge. ift .and. n .le. ilt ) then
                  do ij = 1, nx*ny
                     toa2( ij,k,it,irun ) = to( ij )
                  enddo
               endif
            enddo               !! k

            do m = 1, ncomp
               if( irun .eq. ismodel( m ) ) then
                  do k = 1, nz
                     do ij = 1, nx*ny
                        if( toa2( ij,k,it,irun ) .ne. xmiss ) then
                           toa2s( ij,k,it ) = 
     &                      toa2s( ij,k,it ) + toa2( ij,k,it,irun )
                           itrs( ij,k ) = itrs( ij,k ) + 1 
                        endif
                     enddo
                  enddo
               endif
               if( irun .eq. iwmodel( m ) ) then
                  do k = 1, nz
                     do ij = 1, nx*ny
                        if( toa2( ij,k,it,irun ) .ne. xmiss ) then
                           toa2w( ij,k,it ) = 
     &                      toa2w( ij,k,it ) + toa2( ij,k,it,irun )
                           itrw( ij,k ) = itrw( ij,k ) + 1 
                        endif
                     enddo
                  enddo
               endif
            enddo               !! m

         enddo                  !! irun

         do k = 1, nz
            do ij = 1, nx*ny
               if( itrs( ij,k ) .lt. ncomp ) then
                  toa2s( ij,k,it ) = xmiss
               else
                  toa2s( ij,k,it ) = 
     &                 toa2s( ij,k,it ) / real( itrs( ij,k ) )
               endif
               if( itrw( ij,k ) .lt. ncomp ) then
                  toa2w( ij,k,it ) = xmiss
               else
                  toa2w( ij,k,it ) = 
     &                 toa2w( ij,k,it ) / real( itrw( ij,k ) )
               endif
            enddo
         enddo

      enddo                     !! n

      write( 6,* ) '    @@@ all models '
      trs = 0.
      trw = 0.
      itrs = 0
      itrw = 0
      sig = xmiss
      do irun = 1, nrun+1
         do k = 1, nz
            do ij = 1, nx*ny
               do n = 1, nyr2
                  x1( n ) = toa2( ij,k,n,irun )
               enddo
               call trend( x1, nyr2, xmiss, a_tr1, b_tr1 )
               tr( ij,k,irun ) = a_tr1 * 100. 
               if( a_tr1 .eq. xmiss ) tr( ij,k,irun ) = xmiss
*
* significance for MME
               if( irun .eq. nrun+1 ) then
                  do n = 1, nyr2
                     x1( n ) = real( n )
                     y1( n ) = toa2( ij,k,n,irun )
                  enddo
                  call regcor( x1, y1, nyr2/2, nyr2,
     &                 xmiss, a_tr1, b_tr1, cor1 )
                  if( cor1 .ne. xmiss ) then
                     if( abs( cor1 ) .gt. r99 ) then
                        sig( ij,k ) = 10.
                     else if( abs( cor1 ) .gt. r95 ) then
                        sig( ij,k ) = 5.
                     else if( tr( ij,k,irun ) .eq. xmiss ) then
                        sig( ij,k ) = xmiss
                     endif
                  endif
               endif
*
               do m = 1, ncomp
                  if( irun .eq. ismodel( m ) ) then
                     if( tr( ij,k,irun ) .ne. xmiss ) then
                        trs( ij,k ) = 
     &                       trs( ij,k ) + tr( ij,k,irun )
                        itrs( ij,k ) = itrs( ij,k ) + 1 
                     endif
                  endif
                  if( irun .eq. iwmodel( m ) ) then
                     if( tr( ij,k,irun ) .ne. xmiss ) then
                        trw( ij,k ) = 
     &                       trw( ij,k ) + tr( ij,k,irun )
                        itrw( ij,k ) = itrw( ij,k ) + 1 
                     endif
                  endif
               enddo            !! m
            enddo               !! ij
         enddo                  !! k
      enddo                     !! irun

      do k = 1, nz
         do ij = 1, nx*ny
            if( itrs( ij,k ) .lt. ncomp ) then
               trs( ij,k ) = xmiss
            else
               trs( ij,k ) = trs( ij,k ) / real( itrs( ij,k ) )
            endif
            if( itrw( ij,k ) .lt. ncomp ) then
               trw( ij,k ) = xmiss
            else
               trw( ij,k ) = trw( ij,k ) / real( itrw( ij,k ) )
            endif
         enddo
      enddo

      write( 6,* ) '    @@@ significance for S-models '
      sigs = xmiss
      do k = 1, nz
         do ij = 1, nx*ny
            do n = 1, nyr2
               x1( n ) = real( n )
               y1( n ) = toa2s( ij,k,n )
            enddo
            call trend( y1, nyr2, xmiss, a_tr1, b_tr1 )
            call regcor( x1, y1, nyr2/2, nyr2,
     &                 xmiss, a_tr1, b_tr1, cor1 )
            if( cor1 .ne. xmiss ) then
               if( abs( cor1 ) .gt. r99 ) then
                  sigs( ij,k ) = 10.
               else if( abs( cor1 ) .gt. r95 ) then
                  sigs( ij,k ) = 5.
               else if( a_tr1 .eq. xmiss ) then
                  sigs( ij,k ) = xmiss
               endif
            endif
         enddo                  !! ij
      enddo                     !! k

      write( 6,* ) '    @@@ significance for W-models '
      sigw = xmiss
      do k = 1, nz
         do ij = 1, nx*ny
            do n = 1, nyr2
               x1( n ) = real( n )
               y1( n ) = toa2w( ij,k,n )
            enddo
            call trend( y1, nyr2, xmiss, a_tr1, b_tr1 )
            call regcor( x1, y1, nyr2/2, nyr2,
     &                 xmiss, a_tr1, b_tr1, cor1 )
            if( cor1 .ne. xmiss ) then
               if( abs( cor1 ) .gt. r99 ) then
                  sigw( ij,k ) = 10.
               else if( abs( cor1 ) .gt. r95 ) then
                  sigw( ij,k ) = 5.
               else if( a_tr1 .eq. xmiss ) then
                  sigw( ij,k ) = xmiss
               endif
            endif
         enddo                  !! ij
      enddo                     !! k

      write( 6,* ) '    @@@ ensemble agreement '
      agr = 0.
      agrs = 0.
      agrw = 0.
      do k = 1, nz
         do ij = 1, nx*ny
            if( tr( ij,k,nrun+1 ) .eq. xmiss ) then !! MMEM
               agr( ij,k ) = xmiss
            endif
            if( trs( ij,k ) .eq. xmiss ) then !! S-models
               agrs( ij,k ) = xmiss
            endif
            if( trw( ij,k ) .eq. xmiss ) then !! W-models
               agrw( ij,k ) = xmiss
            endif
         enddo
      enddo                     !! k

      do k = 1, nz
         do ij = 1, nx*ny
            do irun = 1, nrun
               if( agr( ij,k ) .ne. xmiss .and.
     &             tr( ij,k,irun ) .ne. xmiss ) then
                  if( tr( ij,k,nrun+1 )*tr( ij,k,irun ) .ge. 0. ) then  
                     agr( ij,k ) = agr( ij,k ) + 1.
                  endif
               endif
               do m = 1, ncomp
                  if( irun .eq. ismodel( m ) ) then
                     if( agrs( ij,k ) .ne. xmiss .and.
     &                    tr( ij,k,irun ) .ne. xmiss ) then
                        if( trs( ij,k )*tr( ij,k,irun ) .ge. 0. ) then  
                           agrs( ij,k ) = agrs( ij,k ) + 1.
                        endif
                     endif
                  endif
                  if( irun .eq. iwmodel( m ) ) then
                     if( agrw( ij,k ) .ne. xmiss .and.
     &                    tr( ij,k,irun ) .ne. xmiss ) then
                        if( trw( ij,k )*tr( ij,k,irun ) .ge. 0. ) then  
                           agrw( ij,k ) = agrw( ij,k ) + 1.
                        endif
                     endif
                  endif
               enddo
            enddo
            if( agr( ij,k ) .ne. xmiss ) 
     &           agr( ij,k ) = agr( ij,k ) / real( nrun )
            if( agrs( ij,k ) .ne. xmiss ) 
     &           agrs( ij,k ) = agrs( ij,k ) / real( ncomp )
            if( agrw( ij,k ) .ne. xmiss ) 
     &           agrw( ij,k ) = agrw( ij,k ) / real( ncomp )
         enddo
      enddo

      write( 6,* ) '    @@@ write '
      irec = 0
      do irun = 1, nrun+1
         do k = 1, nz
            irec = irec + 1
            write( 93, rec=irec ) ( tr( ij,k,irun ),ij=1,nx*ny )
         enddo
      enddo
      do k = 1, nz
         irec = irec + 1
         write( 93, rec=irec ) ( sig( ij,k ),ij=1,nx*ny )
      enddo
      do k = 1, nz
         irec = irec + 1
         write( 93, rec=irec ) ( agr( ij,k ),ij=1,nx*ny )
      enddo

      irec = 0
      do k = 1, nz
         irec = irec + 1
         write( 94, rec=irec ) ( toclms( ij,k ),ij=1,nx*ny )
         write( 95, rec=irec ) ( toclmw( ij,k ),ij=1,nx*ny )
      enddo
      do k = 1, nz
         irec = irec + 1
         write( 94, rec=irec ) ( trs( ij,k ),ij=1,nx*ny )
         write( 95, rec=irec ) ( trw( ij,k ),ij=1,nx*ny )
      enddo
      do k = 1, nz
         irec = irec + 1
         write( 94, rec=irec ) ( sigs( ij,k ),ij=1,nx*ny )
         write( 95, rec=irec ) ( sigw( ij,k ),ij=1,nx*ny )
      enddo
      do k = 1, nz
         irec = irec + 1
         write( 94, rec=irec ) ( agrs( ij,k ),ij=1,nx*ny )
         write( 95, rec=irec ) ( agrw( ij,k ),ij=1,nx*ny )
      enddo

      close( 92 )
      close( 93 )
      close( 94 )
      close( 95 )
*
      write( 6,* )
      write( 6,* )
     &    ' @@@ Teq in CMIP5 hist+rcp4.5 for 1901-2100: end'
*
      stop
      end
******************
      SUBROUTINE TREND
     I     ( Y, INT, XMISS,
     O      A, B)  
C
C     [variable]
      INTEGER INT
      REAL*4 XMISS
      REAL*4 Y(INT)
C     [internal]
      REAL*4 XM
      REAL*4 YM
      REAL*4 SXY
      REAL*4 SX2
C     [output]
      REAL*4 A
      REAL*4 B
C
C*****TREND*****     
      N=0  
      XM=0.
      YM=0.
      SXY=0. 
      SX2=0. 
C  
      DO 100 I=1,INT         
         IF(Y(I).NE.XMISS) THEN 
            N=N+1           
            XM=XM+REAL(I)         
            YM=YM+Y(I)      
            SXY=SXY+REAL(I)*Y(I)  
            SX2=SX2+REAL(I)**2   
         ENDIF          
  100 CONTINUE       
C     
      IF( N.EQ. INT ) THEN
         XM=XM/REAL(N)     
         YM=YM/REAL(N)     
         A=(SXY-REAL(N)*XM*YM)/(SX2-REAL(N)*XM**2)  
         B=YM-A*XM    
      ELSE
         A=XMISS
         B=XMISS
      ENDIF
C    
      RETURN  
      END       
************************************************
      SUBROUTINE REGCOR
     I     ( X, Y, ITHRE, INT, XMISS,
     O     REGA, REGB, COR ) 
*
      REAL*4 X(INT)
      REAL*4 Y(INT)
      REAL*4 XMISS
      REAL*4 REGA, REGB, COR
*     
*     [work]
      REAL*4 XM
      REAL*4 YM
      REAL*4 SXY
      REAL*4 SX2
      REAL*4 SY2
*     
*
      N = 0 
      XM = 0.E0
      YM = 0.E0 
      SXY = 0.E0
      SX2 = 0.E0
      SY2 = 0.E0
      REG = 0.E0
      COR = 0.E0
*
      DO 100 I = 1, INT
         IF( X( I ) .NE. XMISS .AND. Y( I ) .NE. XMISS ) THEN
            N = N + 1
            XM = XM + X( I )
            YM = YM + Y( I ) 
         ENDIF         
  100 CONTINUE
*
      IF( N .LT. ITHRE ) THEN
         REGA = XMISS
         REGB = XMISS
         COR = XMISS
         GOTO 300
      ELSE
         XM = XM / REAL( N )
         YM = YM / REAL( N )
      ENDIF
*
      DO 200 I = 1, INT
         IF( X( I ) .NE. XMISS .AND. Y( I ) .NE. XMISS ) THEN
            SXY = SXY + ( X( I ) - XM ) * ( Y( I ) - YM )
            SX2 = SX2 + ( X( I ) - XM ) * ( X( I ) - XM )
            SY2 = SY2 + ( Y( I ) - YM ) * ( Y( I ) - YM )
         ENDIF
  200 CONTINUE
*
      IF( SX2 .LE. 1.0E-10 ) THEN
         REGA = XMISS
         REGB = XMISS
         COR = XMISS
      ELSE
         REGA = SXY / SX2
         REGB = YM - XM * REGA
         SXY = SXY / REAL( N )
         SX2 = SQRT( SX2 / REAL( N ) )
         SY2 = SQRT( SY2 / REAL( N ) )
         COR = SXY / SX2 / SY2
      ENDIF
*
  300 RETURN 
      END
