
*     2018/12/18 for extending periods
*     annual mean ocean temp
*     multi model ensemble for 1901-2100 by T Suzuki
*     pre process, kmt:~MIROC4.5/exec/mk_to_ann_xxx.gs
*
      integer  nrun, ncomp 
      integer  nyr, nyr2, ift, ilt, nint, nseg, nx, ny, nz
      integer  iwp1, iwp2, iep1, iep2
      real     xmiss
      parameter ( nrun = 27, ncomp = 6 )
      parameter ( nyr = 200, nyr2 = 50 ) !! 50yr segment for trends
      parameter ( ift = 51, nint = 10, nseg = 11 ) !! 1951-, 1961- .., 2051-2100
      parameter ( nx = 360, ny = 1, nz = 14 )
      parameter ( iwp1 = 111, iwp2 = 180, iep1 = 181, iep2 = 280 )
      parameter ( xmiss = -999. )

      integer   ij, k, l, m, n, ix, irun, irec, ia, ib, ify, ily

      real      to( nx*ny )
      real      toa2( nx*ny,nz,nyr,nrun+1 )
      real      t1
      real      tgrad( nyr,nrun+1 )

      real      tr( nx*ny,nz,nrun+1,nseg )
      real      sig( nx*ny,nz,nseg )
      real      trs( nx*ny,nz,nseg )
      real      sigs( nx*ny,nz,nseg )
      real      trw( nx*ny,nz,nseg )
      real      sigw( nx*ny,nz,nseg )

      real      gtr( nrun,nseg )
      real      gtrs( ncomp,nseg )
      real      gtrw( ncomp,nseg )
      real      gtr_m( nseg ), gtr_s( nseg )
      real      gtrs_m( nseg ), gtrs_s( nseg )
      real      gtrw_m( nseg ), gtrw_s( nseg )

      real      x1( nyr2 )
      real      a_tr1, b_tr1

      integer   itrs( nx*ny,nz )
      integer   itrw( nx*ny,nz )

      integer   ismodel( ncomp )    !! models w/ strengthened SST gradient
      integer   iwmodel( ncomp )    !! models w/ weakened SST gradient

      character cfr1*8
      character cfi( 5 )*90
      character cfo( 6 )*90
      character cmodel( nrun )*14
      data cfr1
     &/'../data/'/
*       12345678901234567890123456789012345678901234567890

      data cfi(1)
     &/'Teq.hist+rcp45.ann.anm.grd'/ 

      data cfo(1)
     &/'Teq.hist+rcp45.ann.anm.trend.segment.grd'/ 
      data cfo(2)
     &/'Teq.hist+rcp45.ann.anm.trend.segment.smodel.grd'/ 
      data cfo(3)
     &/'Teq.hist+rcp45.ann.anm.trend.segment.wmodel.grd'/ 
      data cfo(4)
     &/'Teq.sfc.hist+rcp45.ann.anm.trend.segment.grd'/ 

      data ismodel / 7, 17, 26, 27, 22, 11/
      data iwmodel / 25, 4, 6, 8, 5, 14 /

      write( 6,* )
     &    ' @@@ Teq in CMIP5 hist+rcp4.5 for 1901-2100'

      open( 11,file=cfr1//cfi(1), form='unformatted',
     &     access='direct', recl=4*nx )

      open( 91,file=cfr1//cfo(1), form='unformatted',
     &     access='direct', recl=4*nx )
      open( 92,file=cfr1//cfo(2), form='unformatted',
     &     access='direct', recl=4*nx )
      open( 93,file=cfr1//cfo(3), form='unformatted',
     &     access='direct', recl=4*nx )
      open( 94,file=cfr1//cfo(4), form='unformatted',
     &     access='direct', recl=4 )
*
      write( 6,* )
      write( 6,* )
     &    ' @@@ read To eq anomaly data '
      irec = 0
      do n = 1, nyr 
         do irun = 1, nrun+1
            do k = 1, nz
               irec = irec + 1
               read( 11, rec=irec ) to
               do ij = 1, nx*ny
                  toa2( ij,k,n,irun ) = to( ij )
               enddo
               if( k .eq. 1 ) then
                  call pacific_grad( to, nx, xmiss,
     &                 iwp1, iwp2, iep1, iep2, t1 )
                  tgrad( n,irun ) = t1
               endif
            enddo               !! k
         enddo                  !! irun
      enddo                     !! n
      close( 11 )

      trs = 0.
      trw = 0.
      gtrs = 0.
      gtrw = 0.
      sig = 0.
      sigs = 0.
      sigw = 0.
      do m = 1, nseg
         ify = 1900 + ift + nint * ( m-1 )
         ily = ify + nyr2 - 1
         write( 6,* )
     &        ' @@@ make ', ify, '-', ily, ' trends'
         itrs = 0
         itrw = 0
         igtrs = 0
         igtrw = 0
         do irun = 1, nrun+1
            do k = 1, nz
               do ij = 1, nx*ny
                  do n = 1, nyr2
                     ix = ift + nint * ( m-1 ) + n - 1
                     x1( n ) = toa2( ij,k,ix,irun )
                  enddo
                  call trend( x1, nyr2, xmiss, a_tr1, b_tr1 )
                  tr( ij,k,irun,m ) = a_tr1 * 100. 
                  if( a_tr1 .eq. xmiss ) tr( ij,k,irun,m ) = xmiss
*
                  do l = 1, ncomp
                     if( irun .eq. ismodel( l ) ) then
                        if( tr( ij,k,irun,m ) .ne. xmiss ) then
                           trs( ij,k,m ) = 
     &                       trs( ij,k,m ) + tr( ij,k,irun,m )
                           itrs( ij,k ) = itrs( ij,k ) + 1 
                        endif
                     endif
                     if( irun .eq. iwmodel( l ) ) then
                        if( tr( ij,k,irun,m ) .ne. xmiss ) then
                           trw( ij,k,m ) = 
     &                          trw( ij,k,m ) + tr( ij,k,irun,m )
                           itrw( ij,k ) = itrw( ij,k ) + 1 
                        endif
                     endif
                  enddo         !! l
               enddo            !! ij
            enddo               !! k
*
            do n = 1, nyr2
               ix = ift + nint * ( m-1 ) + n - 1
               x1( n ) = tgrad( ix,irun )
            enddo
            call trend( x1, nyr2, xmiss, a_tr1, b_tr1 )
            if( irun .le. nrun ) gtr( irun,m ) = a_tr1 * 100. 
            if( a_tr1 .eq. xmiss ) gtr( irun,m ) = xmiss
*
            do l = 1, ncomp
               if( irun .eq. ismodel( l ) ) then
                  igtrs = igtrs + 1 
                  if( gtr( irun,m ) .ne. xmiss ) then
                     gtrs( igtrs,m ) = gtr( irun,m )
                  endif
               endif
               if( irun .eq. iwmodel( l ) ) then
                  igtrw = igtrw + 1 
                  if( gtr( irun,m ) .ne. xmiss ) then
                     gtrw( igtrw,m ) = gtr( irun,m )
                  endif
               endif
            enddo               !! l
*
         enddo                  !! irun

         do k = 1, nz
            do ij = 1, nx*ny
               if( itrs( ij,k ) .lt. ncomp ) then
                  trs( ij,k,m ) = xmiss
               else
                  trs( ij,k,m ) = trs( ij,k,m ) / real( itrs( ij,k ) )
               endif
               if( itrw( ij,k ) .lt. ncomp ) then
                  trw( ij,k,m ) = xmiss
               else
                  trw( ij,k,m ) = trw( ij,k,m ) / real( itrw( ij,k ) )
               endif
            enddo
         enddo

         if( m .eq. 1 ) write( 6,* ) '    @@@ significance '
         do k = 1, nz
            do ij = 1, nx*ny
               if( tr( ij,k,nrun+1,m ) .eq. xmiss ) then !! MMEM
                  sig( ij,k,m ) = xmiss
               endif
               if( trs( ij,k,m ) .eq. xmiss ) then !! S-models
                  sigs( ij,k,m ) = xmiss
               endif
               if( trw( ij,k,m ) .eq. xmiss ) then !! W-models
                  sigw( ij,k,m ) = xmiss
               endif
            enddo
         enddo                  !! k

         do k = 1, nz
            do ij = 1, nx*ny
               do irun = 1, nrun
                  if( sig( ij,k,m ) .ne. xmiss .and.
     &             tr( ij,k,irun,m ) .ne. xmiss ) then
                     if( tr( ij,k,nrun+1,m )*tr( ij,k,irun,m ) 
     &                    .ge. 0. ) then  
                        sig( ij,k,m ) = sig( ij,k,m ) + 1.
                     endif
                  endif
                  do l = 1, ncomp
                     if( irun .eq. ismodel( l ) ) then
                        if( sigs( ij,k,m ) .ne. xmiss .and.
     &                       tr( ij,k,irun,m ) .ne. xmiss ) then
                           if( trs( ij,k,m )*tr( ij,k,irun,m ) 
     &                          .ge. 0. ) then  
                              sigs( ij,k,m ) = sigs( ij,k,m ) + 1.
                           endif
                        endif
                     endif
                     if( irun .eq. iwmodel( l ) ) then
                        if( sigw( ij,k,m ) .ne. xmiss .and.
     &                       tr( ij,k,irun,m ) .ne. xmiss ) then
                           if( trw( ij,k,m )*tr( ij,k,irun,m )
     &                          .ge. 0. ) then  
                              sigw( ij,k,m ) = sigw( ij,k,m ) + 1.
                           endif
                        endif
                     endif
                  enddo
               enddo
               if( sig( ij,k,m ) .ne. xmiss ) 
     &              sig( ij,k,m ) = sig( ij,k,m ) / real( nrun )
               if( sigs( ij,k,m ) .ne. xmiss ) 
     &              sigs( ij,k,m ) = sigs( ij,k,m ) / real( ncomp )
               if( sigw( ij,k,m ) .ne. xmiss ) 
     &              sigw( ij,k,m ) = sigw( ij,k,m ) / real( ncomp )
            enddo
         enddo

      enddo                     !! m
*
      call calcmean( gtr, nrun, nseg, xmiss, gtr_m, gtr_s )
      call calcmean( gtrs, ncomp, nseg, xmiss, gtrs_m, gtrs_s )
      call calcmean( gtrw, ncomp, nseg, xmiss, gtrw_m, gtrw_s )
*
      write( 6,* ) ' @@@ write '
      irec = 0
      do m = 1, nseg
         do irun = 1, nrun+1
            do k = 1, nz
               irec = irec + 1
               write( 91, rec=irec ) ( tr( ij,k,irun,m ),ij=1,nx*ny )
            enddo
         enddo
         do k = 1, nz
            irec = irec + 1
            write( 91, rec=irec ) ( sig( ij,k,m ),ij=1,nx*ny )
         enddo
      enddo

      irec = 0
      do m = 1, nseg
         do k = 1, nz
            irec = irec + 1
            write( 92, rec=irec ) ( trs( ij,k,m ),ij=1,nx*ny )
            write( 93, rec=irec ) ( trw( ij,k,m ),ij=1,nx*ny )
         enddo
         do k = 1, nz
            irec = irec + 1
            write( 92, rec=irec ) ( sigs( ij,k,m ),ij=1,nx*ny )
            write( 93, rec=irec ) ( sigw( ij,k,m ),ij=1,nx*ny )
         enddo
      enddo

      irec = 0
      do m = 1, nseg
         do irun = 1, nrun
            irec = irec + 1
            write( 94, rec=irec ) gtr( irun,m )
         enddo
         irec = irec + 1
         write( 94, rec=irec ) gtr_m( m )
         irec = irec + 1
         write( 94, rec=irec ) gtr_s( m )

         irec = irec + 1
         write( 94, rec=irec ) gtrs_m( m )
         irec = irec + 1
         write( 94, rec=irec ) gtrs_s( m )

         irec = irec + 1
         write( 94, rec=irec ) gtrw_m( m )
         irec = irec + 1
         write( 94, rec=irec ) gtrw_s( m )

      enddo

      close( 91 )
      close( 92 )
      close( 93 )
      close( 94 )
*
      write( 6,* )
      write( 6,* )
     &    ' @@@ Teq in CMIP5 hist+rcp4.5 trends: end'
*
      stop
      end
******************
      SUBROUTINE TREND
     I     ( Y, INT, XMISS,
     O      A, B)  
C
C     [variable]
      INTEGER INT
      REAL*4 XMISS
      REAL*4 Y(INT)
C     [internal]
      REAL*4 XM
      REAL*4 YM
      REAL*4 SXY
      REAL*4 SX2
C     [output]
      REAL*4 A
      REAL*4 B
C
C*****TREND*****     
      N=0  
      XM=0.
      YM=0.
      SXY=0. 
      SX2=0. 
C  
      DO 100 I=1,INT         
         IF(Y(I).NE.XMISS) THEN 
            N=N+1           
            XM=XM+REAL(I)         
            YM=YM+Y(I)      
            SXY=SXY+REAL(I)*Y(I)  
            SX2=SX2+REAL(I)**2   
         ENDIF          
  100 CONTINUE       
C     
      IF( N.EQ. INT ) THEN
         XM=XM/REAL(N)     
         YM=YM/REAL(N)     
         A=(SXY-REAL(N)*XM*YM)/(SX2-REAL(N)*XM**2)  
         B=YM-A*XM    
      ELSE
         A=XMISS
         B=XMISS
      ENDIF
C    
      RETURN  
      END       
******************
      subroutine pacific_grad( tin, nx, vms,
     &                 iwp1, iwp2, iep1, iep2, tout )

      integer nx, iwp1, iwp2, iep1, iep2
      integer i, itw, ite, nwp, nep

      real    tin( nx )
      real    tout
      real    tw, te
      real    vms

      tw = 0.
      te = 0.
      itw = 0
      ite = 0
      nwp = iwp2 - iwp1 + 1
      nep = iep2 - iep1 + 1
      do i = 1, nx
         if( tin( i ) .ne. vms ) then
            if( i .ge. iwp1 .and. i .le. iwp2 ) then
               tw = tw + tin( i )
               itw = itw + 1
            endif
            if( i .ge. iep1 .and. i .le. iep2 ) then
               te = te + tin( i )
               ite = ite + 1
            endif
         endif
      enddo

      if( itw .gt. nwp/2 .and. ite .gt. nep/2 ) then
         tout = te/real( ite ) - tw/real( itw )
      else
         tout = vms
      endif

      return
      end
******************
      subroutine calcmean( x, nx, nt, vms, xm, xs )

      integer nx, nt
      integer i, n, ixm

      real    x( nx,nt )
      real    xm( nt ), xs( nt )
      real    vms

      xm = 0.
      xs = 0.
      do n = 1, nt
         ixm = 0
         do i = 1, nx
            if( x( i,n ) .ne. vms ) then
               xm( n ) = xm( n ) + x( i,n )
               ixm = ixm + 1
            endif
         enddo
         if( ixm .lt. nx/2 ) then
            xm( n ) = vms
            xs( n ) = vms
         else
            xm( n ) = xm( n ) / real( ixm )
         endif

         do i = 1, nx
            if( x( i,n ) .ne. vms ) then
               xs( n ) = xs( n ) + ( x( i,n )-xm( n ) )**2
            endif
         enddo
         if( xm( n ) .eq. vms ) then
            xs( n ) = vms
         else
            xs( n ) = sqrt( xs( n ) / real( ixm ) )
         endif
      enddo

      return
      end
