
*     2019/07/08
*     MPI LE
*     clim: 1971-2000
*     anom: 1901-2010
*     pos/neg samples determined from epac_wpac_sst_trend_hist_mpi_le.f

      integer  nt, nt2, ift, nint, nseg, ne, nesub
      real     xmiss

      parameter ( nt = 251 )
      parameter ( nt2 = 50 ) !! 50yr segment for trends
      parameter ( ift = 102, nint = 10, nseg = 11 ) !! 1951-, 1961- .., 2051-2100
      parameter ( ne = 100 )
c      parameter ( nesub = 5 )
      parameter ( nesub = 10 )
      parameter ( xmiss = -999. )

      real    dat1, dat2
      real    dsst( nt,ne )
      real    tr( nseg,ne )
      real    trpos( nseg,ne )
      real    trneg( nseg,ne )

      real    x( nt2 )
      real    a_tr, b_tr

      real    trm( nseg )
      real    trs( nseg )
      real    tr66( nseg )
      real    tr90( nseg )

      real    trposm( nseg )
      real    trposs( nseg )
      real    trpos66( nseg )
      real    trpos90( nseg )

      real    trnegm( nseg )
      real    trnegs( nseg )
      real    trneg66( nseg )
      real    trneg90( nseg )

      integer  n, m, nm, ie, j, irec, nt3, ix
      integer  ipos( nesub )
      integer  ineg( nesub )

      character cfr1*8
      character cfi( 2 )*90
      character cfo( 6 )*90
      data cfr1
     &/'../data/'/
*       12345678901234567890123456789012345678901234567890
 
      data cfi(1)
     &/'sat.mpi-le.epac-wpac.run001-100.ann.anm.grd'/
*       12345678901234567890123456789012345678901234567890

      data cfo(1)
     &/'sat.mpi-le.epac-wpac.trend.segment.grd'/

c      data ipos / 1, 5, 34, 35, 44 /
c      data ineg / 15, 21, 37, 46, 51 /

      data ipos
     &     / 1, 5, 34, 35, 41, 45, 50, 52, 66, 100 /
      data ineg
     &     / 11, 15, 21, 39, 46, 51, 70, 75, 88, 98 /

      write( 6,* ) ' @@@ data opened @@@ '
      open( 10,file=cfr1//cfi(1), form='unformatted',
     &     access='direct', recl=4 )
      open( 91,file=cfr1//cfo(1), form='unformatted',
     &     access='direct', recl=4 )
*
      write( 6,* )
      write( 6,* ) ' @@@ read data @@@ '

      dsst = xmiss
      irec = 0
      do n = 1, nt-1
         do ie = 1, ne
            irec = irec + 1
            read( 10, rec=irec ) dsst( n,ie )
         enddo
      enddo
      close( 10 )

      write( 6,* ) ' @@@ linear trends with 50yr segment'
      tr = xmiss
      do ie = 1, ne
         do m = 1, nseg
            ify = 1849 + ift + nint * ( m-1 )
            ily = ify + nt2 - 1
            if( ie .eq. 1 ) write( 6,* )
     &           ' @@@ make ', ify, '-', ily, ' trends'
            do n = 1, nt2
               ix = ift + nint * ( m-1 ) + n - 1
               x( n ) = dsst( ix,ie )
            enddo
            call trend( x, nt2, xmiss, a_tr, b_tr )
            if( a_tr .ne. xmiss ) tr( m,ie ) = a_tr * 100.
         enddo

         do j = 1, nesub
            if( ie .eq. ipos( j ) ) then
               do m = 1, nseg
                  trpos( m,j ) = tr( m,ie )
               enddo
            endif
            if( ie .eq. ineg( j ) ) then
               do m = 1, nseg
                  trneg( m,j ) = tr( m,ie )
               enddo
            endif
         enddo
      enddo

      call amean( tr, nseg, ne, trm, trs, xmiss )
      call amean( trpos, nseg, nesub, trposm, trposs, xmiss )
      call amean( trneg, nseg, nesub, trnegm, trnegs, xmiss )

      tr66 = xmiss
      tr90 = xmiss
      trpos66 = xmiss
      trpos90 = xmiss
      trneg66 = xmiss
      trneg90 = xmiss
      do n = 1, nseg
         if( trs( n ) .ne. xmiss ) tr66( n ) = trs( n ) * 0.955 !! 66%
         if( trs( n ) .ne. xmiss ) tr90( n ) = trs( n ) * 1.645 !! 90%
         if( trposs( n ) .ne. xmiss ) trpos66( n ) = trposs( n ) * 0.955 !! 66%
         if( trposs( n ) .ne. xmiss ) trpos90( n ) = trposs( n ) * 1.645 !! 90%
         if( trnegs( n ) .ne. xmiss ) trneg66( n ) = trnegs( n ) * 0.955 !! 66%
         if( trnegs( n ) .ne. xmiss ) trneg90( n ) = trnegs( n ) * 1.645 !! 90%
      enddo

      write( 6,* ) ' @@@ write @@@ '
      irec = 0
      do n = 1, nseg
         irec = irec + 1
         write( 91, rec=irec ) trm( n )
         irec = irec + 1
         write( 91, rec=irec ) trs( n )
         irec = irec + 1
         write( 91, rec=irec ) tr66( n )
         irec = irec + 1
         write( 91, rec=irec ) tr90( n )

         irec = irec + 1
         write( 91, rec=irec ) trposm( n )
         irec = irec + 1
         write( 91, rec=irec ) trposs( n )
         irec = irec + 1
         write( 91, rec=irec ) trpos66( n )
         irec = irec + 1
         write( 91, rec=irec ) trpos90( n )

         irec = irec + 1
         write( 91, rec=irec ) trnegm( n )
         irec = irec + 1
         write( 91, rec=irec ) trnegs( n )
         irec = irec + 1
         write( 91, rec=irec ) trneg66( n )
         irec = irec + 1
         write( 91, rec=irec ) trneg90( n )

         do ie = 1, ne
            irec = irec + 1
            write( 91, rec=irec ) tr( n,ie )
         enddo
      enddo
      close( 91 )
*
      stop
      end
************************************************
      subroutine amean( x, nx, ny, xave, xsd, vms )
*
      integer nx, ny
      real    x( nx,ny )
      real    xave( nx )
      real    xsd( nx )
      real    vms
*
      real    xm
      integer n, m, ix

      do n = 1, nx
         xm = 0.
         ix = 0
         do m = 1, ny
            if( x( n,m ) .ne. vms ) then
               xm = xm + x( n,m )
               ix = ix + 1
            endif
         enddo
         if( ix .le. ny/2 ) then
            xave( n ) = vms
         else
            xave( n ) = xm / real( ix )
         endif
*
         xs = 0.
         ix = 0
         do m = 1, ny
            if( x( n,m ) .ne. vms ) then
               xs = xs + ( x( n,m )-xave( n ) )**2
               ix = ix + 1
            endif
         enddo
         if( ix .le. ny/2 ) then
            xsd( n ) = vms
         else
            xsd( n ) = sqrt( xs / real( ix ) )
         endif

      enddo
*
      return
      end
******************
      SUBROUTINE TREND
     I     ( Y, INT, XMISS,
     O      A, B)  
C
C     [variable]
      INTEGER INT
      REAL*4 XMISS
      REAL*4 Y(INT)
C     [internal]
      REAL*4 XM
      REAL*4 YM
      REAL*4 SXY
      REAL*4 SX2
C     [output]
      REAL*4 A
      REAL*4 B
C
C*****TREND*****     
      N=0  
      XM=0.
      YM=0.
      SXY=0. 
      SX2=0. 
C  
      DO 100 I=1,INT         
         IF(Y(I).NE.XMISS) THEN 
            N=N+1           
            XM=XM+REAL(I)         
            YM=YM+Y(I)      
            SXY=SXY+REAL(I)*Y(I)  
            SX2=SX2+REAL(I)**2   
         ENDIF          
  100 CONTINUE       
C     
      IF( N .GE. INT-2 ) THEN
         XM=XM/REAL(N)     
         YM=YM/REAL(N)     
         A=(SXY-REAL(N)*XM*YM)/(SX2-REAL(N)*XM**2)  
         B=YM-A*XM    
      ELSE
         A=XMISS
         B=XMISS
      ENDIF
C    
      RETURN  
      END       
