
*     2019/07/30
*     annual mean, global mean SAT
*
      integer  nrun, ncomp 
      integer  nyr, nyr2, ift, ilt, nint, nseg
      real     xmiss
      parameter ( nrun = 12, ncomp = 6 )
      parameter ( nyr = 200, nyr2 = 50 ) !! 50yr segment for trends
      parameter ( ift = 51, nint = 10, nseg = 11 ) !! 1951-, 1961- .., 2051-2100
      parameter ( xmiss = -999. )

      integer   l, m, n, ix, irun, irec, ia, ib, ify, ily

      real      to
      real      toa2( nyr,nrun+1 )

      real      tr( nrun,nseg )
      real      tro( nseg )
      real      trs( ncomp,nseg )
      real      trw( ncomp,nseg )

      real      tr_m( nseg ), tr_s( nseg )
      real      trs_m( nseg ), trs_s( nseg )
      real      trw_m( nseg ), trw_s( nseg )

      real      x1( nyr2 )
      real      a_tr1, b_tr1

      integer   itrs
      integer   itrw

      integer   ismodel( ncomp )    !! models w/ strengthened SST gradient
      integer   iwmodel( ncomp )    !! models w/ weakened SST gradient

      character cfr1*8
      character cfi( 5 )*90
      character cfo( 6 )*90
      character cmodel( nrun )*14
      data cfr1
     &/'../data/'/
*       12345678901234567890123456789012345678901234567890

      data cfi(1)
     &/'sat.hist+rcp85.run01.ann.anm.glb.mme.subset.grd'/

      data cfo(1)
     &/'sat.hist+rcp85.run01.ann.anm.glb.trend.segment.grd'/ 

      data ismodel / 1, 2, 3, 4, 5, 6 /
      data iwmodel / 7, 8, 9, 10, 11, 12 /

      write( 6,* )
     &    ' @@@ SATg in CMIP5 hist+rcp8.5 for 1901-2100'

      open( 11,file=cfr1//cfi(1), form='unformatted',
     &     access='direct', recl=4 )

      open( 91,file=cfr1//cfo(1), form='unformatted',
     &     access='direct', recl=4 )
*
      write( 6,* )
      write( 6,* )
     &    ' @@@ read SATg anomaly data '
      irec = 0
      do n = 1, nyr 
         do irun = 1, nrun+1
            irec = irec + 1
            read( 11, rec=irec ) to
            if( irun .eq. nrun+1 .and. n .ge. 113 ) to = xmiss
            toa2( n,irun ) = to
         enddo                  !! irun
      enddo                     !! n
      close( 11 )

      trs = 0.
      trw = 0.
      do m = 1, nseg
         ify = 1900 + ift + nint * ( m-1 )
         ily = ify + nyr2 - 1
         write( 6,* )
     &        ' @@@ make ', ify, '-', ily, ' trends'
         itrs = 0
         itrw = 0
         do irun = 1, nrun+1
            do n = 1, nyr2
               ix = ift + nint * ( m-1 ) + n - 1
               x1( n ) = toa2( ix,irun )
            enddo
            call trend( x1, nyr2, xmiss, a_tr1, b_tr1 )
            if( irun .le. nrun ) then
               tr( irun,m ) = a_tr1 * 100. 
               if( a_tr1 .eq. xmiss ) tr( irun,m ) = xmiss
            else
               tro( m ) = a_tr1 * 100. 
               if( a_tr1 .eq. xmiss ) tro( m ) = xmiss
            endif
*
            do l = 1, ncomp
               if( irun .eq. ismodel( l ) ) then
                  itrs = itrs + 1 
                  if( tr( irun,m ) .ne. xmiss ) then
                     trs( itrs,m ) = tr( irun,m )
                  endif
               endif
               if( irun .eq. iwmodel( l ) ) then
                  itrw = itrw + 1 
                  if( tr( irun,m ) .ne. xmiss ) then
                     trw( itrw,m ) = tr( irun,m )
                  endif
               endif
            enddo               !! l
*
         enddo                  !! irun
      enddo                     !! m
*
      call calcmean( tr, nrun, nseg, xmiss, tr_m, tr_s )
      call calcmean( trs, ncomp, nseg, xmiss, trs_m, trs_s )
      call calcmean( trw, ncomp, nseg, xmiss, trw_m, trw_s )
*
      write( 6,* ) ' @@@ write '
      irec = 0
      do m = 1, nseg
         do irun = 1, nrun
            irec = irec + 1
            write( 91, rec=irec ) tr( irun,m )
         enddo
         irec = irec + 1
         write( 91, rec=irec ) tro( m )

         irec = irec + 1
         write( 91, rec=irec ) tr_m( m )
         irec = irec + 1
         write( 91, rec=irec ) tr_s( m )

         irec = irec + 1
         write( 91, rec=irec ) trs_m( m )
         irec = irec + 1
         write( 91, rec=irec ) trs_s( m )

         irec = irec + 1
         write( 91, rec=irec ) trw_m( m )
         irec = irec + 1
         write( 91, rec=irec ) trw_s( m )

      enddo

      close( 91 )
*
      write( 6,* )
      write( 6,* )
     &    ' @@@ SATg in CMIP5 hist+rcp8.5 trends: end'
*
      stop
      end
******************
      SUBROUTINE TREND
     I     ( Y, INT, XMISS,
     O      A, B)  
C
C     [variable]
      INTEGER INT
      REAL*4 XMISS
      REAL*4 Y(INT)
C     [internal]
      REAL*4 XM
      REAL*4 YM
      REAL*4 SXY
      REAL*4 SX2
C     [output]
      REAL*4 A
      REAL*4 B
C
C*****TREND*****     
      N=0  
      XM=0.
      YM=0.
      SXY=0. 
      SX2=0. 
C  
      DO 100 I=1,INT         
         IF(Y(I).NE.XMISS) THEN 
            N=N+1           
            XM=XM+REAL(I)         
            YM=YM+Y(I)      
            SXY=SXY+REAL(I)*Y(I)  
            SX2=SX2+REAL(I)**2   
         ENDIF          
  100 CONTINUE       
C     
      IF( N.EQ. INT ) THEN
         XM=XM/REAL(N)     
         YM=YM/REAL(N)     
         A=(SXY-REAL(N)*XM*YM)/(SX2-REAL(N)*XM**2)  
         B=YM-A*XM    
      ELSE
         A=XMISS
         B=XMISS
      ENDIF
C    
      RETURN  
      END       
******************
      subroutine calcmean( x, nx, nt, vms, xm, xs )

      integer nx, nt
      integer i, n, ixm

      real    x( nx,nt )
      real    xm( nt ), xs( nt )
      real    vms

      xm = 0.
      xs = 0.
      do n = 1, nt
         ixm = 0
         do i = 1, nx
            if( x( i,n ) .ne. vms ) then
               xm( n ) = xm( n ) + x( i,n )
               ixm = ixm + 1
            endif
         enddo
         if( ixm .lt. nx/2 ) then
            xm( n ) = vms
            xs( n ) = vms
         else
            xm( n ) = xm( n ) / real( ixm )
         endif

         do i = 1, nx
            if( x( i,n ) .ne. vms ) then
               xs( n ) = xs( n ) + ( x( i,n )-xm( n ) )**2
            endif
         enddo
         if( xm( n ) .eq. vms ) then
            xs( n ) = vms
         else
            xs( n ) = sqrt( xs( n ) / real( ixm ) )
         endif
      enddo

      return
      end
